Skip to main content
GET
Get Series Observations

Request contract

  • Method and path: GET /apis/v1/fred/series/observations
  • Availability: enabled
  • Request URL template: https://api.aisa.one/apis/v1/fred/series/observations
  • aggregation_method: query; optional
  • file_type: query; optional
  • frequency: query; optional
  • limit: query; optional
  • observation_end: query; optional
  • observation_start: query; optional
  • offset: query; optional
  • output_type: query; optional
  • realtime_end: query; optional
  • realtime_start: query; optional
  • series_id: query; required
  • sort_order: query; optional
  • units: query; optional
  • vintage_dates: query; optional
  • Runtime facts: 99b84812775a5b511e5b561db33dbfe37ed3954afbc7b30caf10377dcd683c23
Complete OpenAPI definition Effective request and pricing declaration (including authentication and referenced schemas):

Cost and request rules

Published reference price: $0.00001 USD per successful request. Account-specific pricing and final settlement may differ. Published reference values are not an account-specific quote or a settled charge. For endpoints supporting X-AISA-Cost-Mode: quote, obtain a free quote for your exact request before execution; reconcile the settled cost with response metadata and Usage Logs. USD amounts use 1,000,000 integer micro-USD per dollar.
  • Default request reference estimate (USD): 1e-05
  • Cost contract: fixed_success
  • Settlement evidence source: request_snapshot

Authorizations

Authorization
string
header
required

Bearer authentication header of the form Bearer <token>, where <token> is your auth token.

Query Parameters

aggregation_method
enum<string>
default:avg

A key that indicates the aggregation method used for frequency aggregation. This parameter has no affect if the frequency parameter is not set. string, optional, default: avg One of the following values: 'avg', 'sum', 'eop' avg = Average sum = Sum eop = End of Period avg = Average sum = Sum eop = End of Period

Available options:
avg,
sum,
eop
file_type
enum<string>
default:xml

A key or file extension that indicates the type of file to send. string, optional, default: xml One of the following values: 'xml', 'json', 'xlsx', 'csv' xml = Extensible Markup Language json = JavaScript Object Notation xlsx = Excel Spreadsheet csv = Comma-Separated Values Text Format (File is returned as compressed zip file. The zip file contains the specified file format csv and a text README file.) xml = Extensible Markup Language json = JavaScript Object Notation xlsx = Excel Spreadsheet csv = Comma-Separated Values Text Format (File is returned as compressed zip file. The zip file contains the specified file format csv and a text README file.)

Available options:
xml,
json,
xlsx,
csv
frequency
enum<string>

An optional parameter that indicates a lower frequency to aggregate values to. The FRED frequency aggregation feature converts higher frequency data series into lower frequency data series (e.g. converts a monthly data series into an annual data series). In FRED, the highest frequency data is daily, and the lowest frequency data is annual. There are 3 aggregation methods available- average, sum, and end of period. See the aggregation_method parameter. string, optional, default: no value for no frequency aggregation One of the following values: 'd', 'w', 'bw', 'm', 'q', 'sa', 'a', 'wef', 'weth', 'wew', 'wetu', 'wem', 'wesu', 'wesa', 'bwew', 'bwem' Frequencies without period descriptions: d = Daily w = Weekly bw = Biweekly m = Monthly q = Quarterly sa = Semiannual a = Annual Frequencies with period descriptions: wef = Weekly, Ending Friday weth = Weekly, Ending Thursday wew = Weekly, Ending Wednesday wetu = Weekly, Ending Tuesday wem = Weekly, Ending Monday wesu = Weekly, Ending Sunday wesa = Weekly, Ending Saturday bwew = Biweekly, Ending Wednesday bwem = Biweekly, Ending Monday Frequencies without period descriptions: d = Daily w = Weekly bw = Biweekly m = Monthly q = Quarterly sa = Semiannual a = Annual d = Daily w = Weekly bw = Biweekly m = Monthly q = Quarterly sa = Semiannual a = Annual Frequencies with period descriptions: wef = Weekly, Ending Friday weth = Weekly, Ending Thursday wew = Weekly, Ending Wednesday wetu = Weekly, Ending Tuesday wem = Weekly, Ending Monday wesu = Weekly, Ending Sunday wesa = Weekly, Ending Saturday bwew = Biweekly, Ending Wednesday bwem = Biweekly, Ending Monday wef = Weekly, Ending Friday weth = Weekly, Ending Thursday wew = Weekly, Ending Wednesday wetu = Weekly, Ending Tuesday wem = Weekly, Ending Monday wesu = Weekly, Ending Sunday wesa = Weekly, Ending Saturday bwew = Biweekly, Ending Wednesday bwem = Biweekly, Ending Monday Note that an error will be returned if a frequency is specified that is higher than the native frequency of the series. For instance if a series has the native frequency 'Monthly' (as returned by the fred/series request), it is not possible to aggregate the series to the higher 'Daily' frequency using the frequency parameter value 'd'. No frequency aggregation will occur if the frequency specified by the frequency parameter matches the native frequency of the series. For instance if the value of the frequency parameter is 'm' and the native frequency of the series is 'Monthly' (as returned by the fred/series request), observations will be returned, but they will not be aggregated to a lower frequency. For most cases, it will be sufficient to specify a lower frequency without a period description (e.g. 'd', 'w', 'bw', 'm', 'q', 'sa', 'a') as opposed to frequencies with period descriptions (e.g. 'wef', 'weth', 'wew', 'wetu', 'wem', 'wesu', 'wesa', 'bwew', 'bwem') which only exist for the weekly and biweekly frequencies. The weekly and biweekly frequencies with periods exist to offer more options and override the default periods implied by values 'w' and 'bw'. The value 'w' defaults to frequency and period 'Weekly, Ending Friday' when aggregating daily series. The value 'bw' defaults to frequency and period 'Biweekly, Ending Wednesday' when aggregating daily and weekly series. Consider the difference between values 'w' for 'Weekly' and 'wef' for 'Weekly, Ending Friday'. When aggregating observations from daily to weekly, the value 'w' defaults to frequency and period 'Weekly, Ending Friday' which is the same as 'wef'. Here, the difference is that the period 'Ending Friday' is implicit for value 'w' but explicit for value 'wef'. However, if a series has native frequency 'Weekly, Ending Monday', an error will be returned for value 'wef' but not value 'w'. The weekly and biweekly frequencies with periods exist to offer more options and override the default periods implied by values 'w' and 'bw'. The value 'w' defaults to frequency and period 'Weekly, Ending Friday' when aggregating daily series. The value 'bw' defaults to frequency and period 'Biweekly, Ending Wednesday' when aggregating daily and weekly series. Consider the difference between values 'w' for 'Weekly' and 'wef' for 'Weekly, Ending Friday'. When aggregating observations from daily to weekly, the value 'w' defaults to frequency and period 'Weekly, Ending Friday' which is the same as 'wef'. Here, the difference is that the period 'Ending Friday' is implicit for value 'w' but explicit for value 'wef'. However, if a series has native frequency 'Weekly, Ending Monday', an error will be returned for value 'wef' but not value 'w'. Note that frequency aggregation is currently only available for file_type equal to xml or json due to time constraints. Read the 'Frequency Aggregation' section of the FRED FAQs for implementation details.

Available options:
d,
w,
bw,
m,
q,
sa,
a,
wef,
weth,
wew,
wetu,
wem,
wesu,
wesa,
bwew,
bwem
limit
integer
default:100000

The maximum number of results to return. integer between 1 and 100000, optional, default: 100000

Required range: 1 <= x <= 100000
observation_end
string<date>
default:9999-12-31

The end of the observation period. YYYY-MM-DD formatted string, optional, default: 9999-12-31 (latest available)

observation_start
string<date>
default:1776-07-04

The start of the observation period. YYYY-MM-DD formatted string, optional, default: 1776-07-04 (earliest available)

offset
integer
default:0

non-negative integer, optional, default: 0

Required range: x >= 0
output_type
enum<integer>
default:1

An integer that indicates an output type. integer, optional, default: 1 One of the following values: '1', '2', '3', '4' 1 = Observations by Real-Time Period 2 = Observations by Vintage Date, All Observations 3 = Observations by Vintage Date, New and Revised Observations Only 4 = Observations, Initial Release Only 1 = Observations by Real-Time Period 2 = Observations by Vintage Date, All Observations 3 = Observations by Vintage Date, New and Revised Observations Only 4 = Observations, Initial Release Only For output types '2' and '3', some XML attribute names start with the series ID which may have a first character that is a number (i.e. 0 through 9). In this case only, the XML attribute name starts with an underscore then the series ID in order to avoid invalid XML. If the series ID starts with a letter (i.e. A through Z) then an underscore is not prepended. For more information, read: https://alfred.stlouisfed.org/help/downloaddata#outputformats

Available options:
1,
2,
3,
4
realtime_end
string<date>

The end of the real-time period. For more information, see Real-Time Periods , vintage_dates . YYYY-MM-DD formatted string, optional, default: today's date

realtime_start
string<date>

The start of the real-time period. For more information, see Real-Time Periods , vintage_dates . YYYY-MM-DD formatted string, optional, default: today's date

series_id
string
required

The id for a series. string, required

sort_order
enum<string>
default:asc

Sort results is ascending or descending observation_date order. One of the following strings: 'asc', 'desc'. optional, default: asc

Available options:
asc,
desc
units
enum<string>
default:lin

A key that indicates a data value transformation. string, optional, default: lin (No transformation) One of the following values: 'lin', 'chg', 'ch1', 'pch', 'pc1', 'pca', 'cch', 'cca', 'log' lin = Levels (No transformation) chg = Change ch1 = Change from Year Ago pch = Percent Change pc1 = Percent Change from Year Ago pca = Compounded Annual Rate of Change cch = Continuously Compounded Rate of Change cca = Continuously Compounded Annual Rate of Change log = Natural Log lin = Levels (No transformation) chg = Change ch1 = Change from Year Ago pch = Percent Change pc1 = Percent Change from Year Ago pca = Compounded Annual Rate of Change cch = Continuously Compounded Rate of Change cca = Continuously Compounded Annual Rate of Change log = Natural Log For unit transformation formulas, see: https://alfred.stlouisfed.org/help#growth_formulas

Available options:
lin,
chg,
ch1,
pch,
pc1,
pca,
cch,
cca,
log
vintage_dates
string

A comma separated string of YYYY-MM-DD formatted dates in history (e.g. 2000-01-01,2005-02-24). Vintage dates are used to download data as it existed on these specified dates in history. Vintage dates can be specified instead of a real-time period using realtime_start and realtime_end. Sometimes it may be useful to enter a vintage date that is not a date when the data values were revised. For instance you may want to know the latest available revisions on a particular date. Entering a vintage date is also useful to compare series on different releases with different release dates. string, optional, no vintage dates are set by default. Your query will be limited to a specific number of vintage dates depending on the series_id , file_type and output_type specified. output_type=2, series_id=USRECD: 110 csv, 55 xlsx output_type=2, any daily series: 450 csv, 225 xlsx any output_type or other series: 1000 csv, 1000 xlsx, 2000 json, 2000 xml

Response

Official representation and examples only; no complete response schema is declared.